open Ast

let import_decl = "
import java.io.File;
import java.util.Formatter;
import java.util.Scanner;
import Jama.*;
"
let class_decl = "\n"^
"enum OPERATION {ADD, SUB, MUL, DIV, EMUL, ELDIV, ERDIV, LDIV, POW};\n"^
"static String numFormat = \"short\";\n"^
"    static void setNumFormat(String s){\n"^
"        numFormat=s;\n"^
"    }\n"^
"    static void disp(Object o) {\n"^
"        if (o instanceof String) {\n"^
"            System.out.println((String) o);\n"^
"        } else if (o instanceof Integer) {\n"^
"            Integer a = (Integer) o;\n"^
"            System.out.println(a.toString());\n"^
"        } else if (o instanceof Double) {\n"^
"            if (numFormat.equals(\"short\")) {\n"^
"                String fString = \"%\" + \"01\" + \".\" + 4 + \"f\\n\";\n"^
"                Double a = (Double) o;\n"^
"               System.out.format(fString, a);\n"^
"            } else if (numFormat.equals(\"shortE\")) {\n"^
"                String fString = \"%\" + \"1\" + \".\" + 4 + \"E\";\n"^
"                Double a = (Double) o;\n"^
"                System.out.format(fString, a);\n"^
"            }else if (numFormat.equals(\"long\")){\n"^
"                String fString = \"%\" + \"1\" + \".\" + 10 + \"f\";\n"^
"                Double a = (Double) o;\n"^
"                System.out.format(fString, a);\n"^
"            }else if (numFormat.equals(\"longE\")){\n"^
"                String fString = \"%\" + \"01\" + \".\" + 10 + \"E\";\n"^
"                Double a = (Double) o;\n"^
"                System.out.format(fString, a);\n"^
"            }\n"^
"        }else if (o instanceof Matrix){\n"^
"            Matrix m=(Matrix) o;\n"^
"            String conversion=\"\";\n"^
"            int numDecimal=4;\n"^
"            if (numFormat.equals(\"short\") || numFormat.equals(\"shortE\")){\n"^
"                numDecimal=4;\n"^
"                if (numFormat.equals(\"short\")){\n"^
"                    conversion=\"f\";\n"^
"                }else{\n"^
"                    conversion=\"E\";\n"^
"                }\n"^
"            }else if(numFormat.equals(\"long\") || numFormat.equals(\"longE\")){\n"^
"                numDecimal=15;\n"^
"                if (numFormat.equals(\"long\")){\n"^
"                    conversion=\"f\";\n"^
"                }else{\n"^
"                    conversion=\"E\";\n"^
"                }\n"^
"            }\n"^
"            String formatStr=\"%\"+\"1\"+\".\"+numDecimal+conversion;\n"^
"            int maxWidth=0;\n"^
"            for (int i=0; i<m.getRowDimension(); i++){\n"^
"                for (int j=0; j<m.getColumnDimension(); j++){\n"^
"                    String testStr=String.format(formatStr, m.get(i, j));\n"^
"                   if (testStr.length()>maxWidth){\n"^
"                        maxWidth=testStr.length();\n"^
"                    }\n"^
"                }\n"^
"            }\n"^
"           maxWidth+=6;\n"^
"            for (int i=0; i<m.getRowDimension(); i++){\n"^
"                for (int j=0; j<m.getColumnDimension(); j++){\n"^
"                    formatStr=\"%\"+maxWidth+\".\"+numDecimal+conversion;\n"^
"                    String testStr=String.format(formatStr, m.get(i, j));\n"^
"                    System.out.print(testStr);\n"^
"                }\n"^
"                System.out.println();\n"^
"            }\n"^
"        }\n"^
"    }\n"^
"    static Matrix matrixOperations(Object op1, Object op2, OPERATION op) {\n"^
"        if (op1 instanceof Matrix && (op2 instanceof Integer || op2 instanceof Double)) {\n"^
"            Matrix temp1 = (Matrix) op1;\n"^
"            Matrix temp2 = new Matrix(temp1.getRowDimension(), temp1.getColumnDimension(), Double.parseDouble(op2.toString()));\n"^
"            Matrix temp3=new Matrix(temp1.getRowDimension(), temp1.getColumnDimension());\n"^
"            switch (op) {\n"^
"                case ADD:\n"^
"                    return temp1.plus(temp2);\n"^
"                case SUB:\n"^
"                    return temp1.minus(temp2);\n"^
"                case MUL:\n"^
"                    return temp1.times(Double.parseDouble(op2.toString()));\n"^
"                case DIV:\n"^
"                    for (int i = 0; i < temp1.getRowDimension(); i++) {\n"^
"                        for (int j = 0; j < temp1.getColumnDimension(); j++) {\n"^
"                            double product = temp1.get(i, j) / temp2.get(i,j);\n"^
"                            temp3.set(i, j, product);\n"^
"                        }\n"^
"                    }\n"^
"                    return temp3;\n"^
"                case POW:\n"^
"                    for (int i = 0; i < temp1.getRowDimension(); i++) {\n"^
"                        for (int j = 0; j < temp1.getColumnDimension(); j++) {\n"^
"                            double product = Math.pow(temp1.get(i, j), temp2.get(i,j));\n"^
"                            temp1.set(i, j, product);\n"^
"                        }\n"^
"                    }\n"^
"                    return temp1;\n"^
"            }\n"^
"          }else if((op1 instanceof Integer || op1 instanceof Double) && op2 instanceof Matrix) {\n"^
"              Matrix temp1 = (Matrix) op2;\n"^
"               Matrix temp2 = new Matrix(temp1.getRowDimension(), temp1.getColumnDimension(), Double.parseDouble(op1.toString()));\n"^
"		Matrix temp3=new Matrix(temp1.getRowDimension(), temp1.getColumnDimension());\n"^
"              switch (op) {\n"^
"                case ADD:\n"^
"                    return temp1.plus(temp2);\n"^
"                case SUB:\n"^
"                    return temp1.minus(temp2);\n"^
"                case MUL:\n"^
"                    return temp1.times(Double.parseDouble(op1.toString()));\n"^
"                case DIV:\n"^
"                    for (int i = 0; i < temp1.getRowDimension(); i++) {\n"^
"                        for (int j = 0; j < temp1.getColumnDimension(); j++) {\n"^
"                            double product = temp2.get(i, j) / temp1.get(i,j);\n"^
"                            temp3.set(i, j, product);\n"^
"                        }\n"^
"                    }\n"^
"                    return temp3;\n"^
"               }\n"^
"            }else if (op1 instanceof Matrix && op2 instanceof Matrix) {\n"^
"            Matrix temp1 = (Matrix) op1;\n"^
"            Matrix temp2 = (Matrix) op2;\n"^
"            switch (op) {\n"^
"                case ADD:\n"^
"                    return temp1.plus(temp2);\n"^
"                case SUB:\n"^
"                    return temp1.minus(temp2);\n"^
"                case MUL:\n"^
"                    return temp1.times(temp2);\n"^
"                case EMUL:\n"^
"                    return temp1.arrayTimes(temp2);\n"^
"                case ELDIV:\n"^
"                    return temp1.arrayLeftDivide(temp2);\n"^
"                case LDIV:\n"^
"                    return temp1.solve(temp2);\n"^
"                case ERDIV:\n"^
"                    return temp1.arrayRightDivide(temp2);\n"^
"            }\n"^
"        }\n"^
"        return null;\n"^
"    }\n"^
"static Matrix matrixInit(int row, int col, double [] array){\n"^
"        double [][]m=new double[row][col];\n"^
"        int arrayIndex=0;\n"^
"        for (int i=0; i<row;i++ ){\n"^
"            for (int j=0; j<col; j++){\n"^
"               m[i][j]=array[arrayIndex];\n"^
"                arrayIndex++;\n"^
"            }\n"^
"        }\n"^
"        return new Matrix(m);\n"^
"    }\n"^
"public static int getHeight(Matrix M){\n"^
"        return M.getRowDimension();\n"^
"}\n"^
"public static int getWidth(Matrix M){\n"^
"        return M.getColumnDimension();\n"^
"}\n"^
"static Matrix getSubMatrix(Matrix M, int i0, int i1, int j0, int j1){\n"^
"        int start1=0;\n"^
"        int finish1=0;\n"^
"        int start2=0;\n"^
"        int finish2=0;\n"^
"        if (i0==-1 && i1==-1){\n"^
"            start1=0;\n"^
"            finish1=M.getRowDimension();\n"^
"        }else{\n"^
"            start1=i0;\n"^
"            finish1=i1;\n"^
"        }\n"^
"        if (j0==-1 && j1==-1){\n"^
"            start2=0;\n"^
"            finish2=M.getColumnDimension();\n"^
"        }else{\n"^
"            start2=j0;\n"^
"            finish2=j1;\n"^
"        }\n"^
"        return M.getMatrix(start1, finish1, start2, finish2);\n"^
"}\n"^
"    public static String[] getFields(String line, String delimiters) {\n"^
"        java.util.StringTokenizer st = new java.util.StringTokenizer(line, delimiters);\n"^
"        int fieldCnt = st.countTokens();\n"^
"        String[] fields = new String[fieldCnt];\n"^
"        for (int i = 0; i < fieldCnt; i++) {\n"^
"            fields[i] = st.nextToken();\n"^
"        }\n"^
"        return fields;\n"^
"    }\n"^
"    public static void save(Matrix data, String name) {\n"^
"        File outputFile = new File(\".\" + File.separator + name + \".mat\");\n"^
"        Formatter output = null;\n"^
"        try {\n"^
"            output = new Formatter(outputFile);\n"^
"        } catch (Exception e) {\n"^
"            e.printStackTrace();\n"^
"        }\n"^
"        output.format(\"%d,%d\\n\", data.getRowDimension(), data.getColumnDimension());\n"^
"        for (int i = 0; i < data.getRowDimension(); i++) {\n"^
"            for (int j = 0; j < data.getColumnDimension(); j++) {\n"^
"                output.format(\"%e\", data.get(i, j));\n"^
"                if (j != data.getColumnDimension() - 1) {\n"^
"                    output.format(\"%s\", \",\");\n"^
"                }\n"^
"            }\n"^
"            output.format(\"%s\\n\", \"\");\n"^
"        }\n"^
"        output.flush();\n"^
"        output.close();\n"^
"    }\n"^
"    public static Matrix load( String name) {\n"^
"        File inputFile = new File(\".\" + File.separator + name + \".mat\");\n"^
"        Scanner input=null;\n"^
"        String lStr=\"\";\n"^
"        try {\n"^
"            input=new Scanner(inputFile);\n"^
"        } catch (Exception e) {\n"^
"           e.printStackTrace();\n"^
"       }\n"^
"       String []fields;\n"^
"       lStr=input.nextLine();\n"^
"        fields=getFields(lStr,\",\");\n"^
"        int nRows=Integer.parseInt(fields[0]);\n"^
"        int nCols=Integer.parseInt(fields[1]);\n"^
"        double [][] inputM=new double[nRows][nCols];\n"^
"        for (int i=0; i<nRows; i++){\n"^
"            lStr=input.nextLine();\n"^
"            fields=getFields(lStr,\",\");\n"^
"            for (int j=0; j<nCols; j++){\n"^
"                inputM[i][j]=Double.parseDouble(fields[j]);\n"^
"            }\n"^
"        }\n"^
"        Matrix oM=new Matrix(inputM);\n"^
"        return oM;\n"^
"    }\n"

(* initialize all variables *)
let initial_value vtype =
  if vtype = "void" then ""
  else if vtype = "int" then "0"
  else if vtype = "float" then "0.0"
  else if vtype = "string" then ""
  else if vtype = "boolean" then "false"
  else if vtype = "matrix" then "new Matrix(1,1)"
  else
    raise (Failure ("unrecognized type: " ^ vtype))

(* convert ODESL data type to Java data type *)
let java_type_of vtype =
  if vtype = "void" then "void"
  else if vtype = "int" then "Integer"
  else if vtype = "float" then "Double"
  else if vtype = "string" then "String"
  else if vtype = "boolean" then "Boolean"
  else if vtype = "matrix" then "Matrix"
  else
    raise (Failure ("unrecognized type: " ^ vtype))

let fsignature fdecl =
  if fdecl.fname = "main" then "public static void main(String[] args)"
  (* else "public static int " ^ fdecl.fname ^ "(int " ^ String.concat ", int " fdecl.formals ^ ")" *)
  else
    let formal_string_list = List.fold_left (fun f_list formal -> (java_type_of formal.vartype ^ " " ^ formal.varname)::f_list) [] fdecl.formals
    in
    "public static " ^ java_type_of fdecl.rettype ^ " " ^ fdecl.fname ^ "(" ^ String.concat "," (List.rev formal_string_list) ^ ")"


let fcall f =
  if f = "disp" then "disp"
  else if f = "width" then "getWidth"
  else if f = "height" then "getHeight"
  else if f = "sqrt" then "Math.sqrt"
  else if f = "abs" then "Math.abs"
  else if f = "exp" then "Math.exp"
  else if f = "log" then "Math.log"
  else if f = "log10" then "Math.log10"
  else if f = "sin" then "Math.sin"
  else if f = "cos" then "Math.cos"
  else if f = "tan" then "Math.tan"
  else if f = "asin" then "Math.asin"
  else if f = "acos" then "Math.acos"
  else if f = "atan" then "Math.atan"
  else if f = "atan2" then "Math.atan2"
  else if f = "setFormat" then "setNumFormat"
  else if f = "save" then "save"
  else if f = "load" then "load"
  else f

(* build a list of 'num' elements of name *)
let rec build_list (name, num, l) =
  if num = 0 then l
  else build_list (name, num-1, name::l)


(* returns the type of an expression*)
let rec type_of_expr symbols = function
    Literal(l) -> { varname = string_of_int l; vartype = "int" }
  | Floatlit(f) -> { varname = string_of_float f; vartype = "float" }
  | String(s) -> { varname = s; vartype = "string" }
  | Bool(s) -> { varname = s; vartype = "boolean" } 
  | Id(s) ->
      (* try to find it in local table first *)
      let exists = List.exists (fun a -> if a.varname = s then true else false) symbols
      in
      if exists then
        let var = List.find (fun a -> if a.varname = s then true else false) symbols
        in
        var
      else (* then try to find it in global table *)
        let exists2 = List.exists (fun a -> if a.varname = s ^ "_global_var" then true else false) symbols
        in
        if exists2 then
          let var = List.find (fun a -> if a.varname = s ^ "_global_var" then true else false) symbols
          in
          { varname = s; vartype = var.vartype }
        else
          raise (Failure ("Unable to find " ^ s ^ " in symbol table"))
      (**
      let var_list = List.find_all (fun a -> if a.varname = s then true else false) symbols
      in
      if List.length var_list > 1 then
        raise (Failure ("Functions and variables cannot share the same name: '" ^ s ^ "'"))
      else
        List.hd var_list
      **)
  | Paren(e)->let pe = type_of_expr symbols e
      in pe
  | Uminus(e) ->
      let ue = type_of_expr symbols e
      in ue
  | Not(e) ->
      let ne = type_of_expr symbols e
      in ne
  | Binop(e1, o, e2) -> begin
      match o with
        Equal | Neq | Less | Leq | Greater | Geq ->
        { varname = "null"; vartype = "boolean" }
      | _ -> (* The rest of expr have the same type as the first operand *)
        let e = type_of_expr symbols e1
        in e
    end
  | Assign(v, e) ->
      (* try to find it in local table first *)
      let exists = List.exists (fun a -> if a.varname = v then true else false) symbols
      in
      if exists then
        let var = List.find (fun a -> if a.varname = v then true else false) symbols
        in
        var
      else (* then try to find it in global table *)
        let exists2 = List.exists (fun a -> if a.varname = v ^ "_global_var" then true else false) symbols
        in
        if exists2 then
          let var = List.find (fun a -> if a.varname = v ^ "_global_var" then true else false) symbols
          in
          { varname = v; vartype = var.vartype }
        else
          raise (Failure ("Unable to find " ^ v ^ " in symbol table"))      
  | Call(f, el) ->
      let exists = List.exists (fun a -> if a.varname = f ^ "_global_func" then true else false) symbols
      in
      if exists then (* if f is in our symbole table *)
        let ff = List.find (fun a -> if a.varname = f ^ "_global_func" then true else false) symbols
        in
        { varname = f; vartype = ff.vartype }
      else if f = "width" then
        { varname = "width"; vartype = "int" }
      else if f = "getheight" then
        { varname = "height"; vartype = "int" }
      else if f = "load" then
        { varname = "load"; vartype = "matrix" }
      else if f = "inv" then
        { varname = "inverse"; vartype = "matrix" }
      else if f = "sqrt" then
        let arg = List.hd el
        in
        let e = type_of_expr symbols arg
        in
        if e.vartype = "int" || e.vartype ="float" then
          { varname = "sqrt"; vartype = "float" }
        else (* walker should block this*)
          { varname = ""; vartype = "" }
        else if f = "abs" then 
           let arg = List.hd el
	   in
	   let e = type_of_expr symbols arg
           in
           {varname=e.varname; vartype=e.vartype}
        else if f = "exp" then 
           let arg = List.hd el
	   in
	   let e = type_of_expr symbols arg
           in
           {varname=e.varname; vartype=e.vartype}
        else if f = "log" then 
           let arg = List.hd el
	   in
	   let e = type_of_expr symbols arg
           in
           {varname=e.varname; vartype=e.vartype}
        else if f = "log10" then 
           let arg = List.hd el
	   in
	   let e = type_of_expr symbols arg
           in
           {varname=e.varname; vartype=e.vartype}
        else if f = "sin" then 
           let arg = List.hd el
	   in
	   let e = type_of_expr symbols arg
           in
           {varname=e.varname; vartype=e.vartype}
        else if f = "cos" then 
           let arg = List.hd el
	   in
	   let e = type_of_expr symbols arg
           in
           {varname=e.varname; vartype=e.vartype}
        else if f = "tan" then 
           let arg = List.hd el
	   in
	   let e = type_of_expr symbols arg
           in
           {varname=e.varname; vartype=e.vartype}
        else if f = "asin" then 
           let arg = List.hd el
	   in
	   let e = type_of_expr symbols arg
           in
           {varname=e.varname; vartype=e.vartype}
        else if f = "acos" then 
           let arg = List.hd el
	   in
	   let e = type_of_expr symbols arg
           in
           {varname=e.varname; vartype=e.vartype}
        else if f = "atan" then 
           let arg = List.hd el
	   in
	   let e = type_of_expr symbols arg
           in
           {varname=e.varname; vartype=e.vartype}
        else if f = "atan2" then 
           let arg = List.hd el
	   in
	   let e = type_of_expr symbols arg
           in
           {varname=e.varname; vartype=e.vartype}
        else if f = "mod" then 
           let arg = List.hd el
	   in
	   let e = type_of_expr symbols arg
           in
           {varname=e.varname; vartype=e.vartype} 
        else if f = "setFormat" then 
           {varname="setFoprmat"; vartype="void"}
        else if f = "save" then 
           {varname="save"; vartype="void"}
        else if f = "load" then 
            {varname="load"; vartype="matrix"}
        else if f = "tostring" then
        { varname = "tostring"; vartype = "string" }
     else
        { varname = ""; vartype = "" }
  | _ -> { varname = ""; vartype = "" }

(* given variable v, find it in symbol table *)
let rec find_symbol symbols v =
  (* try to find it in local table first *)
  let exists = List.exists (fun a -> if a.varname = v then true else false) symbols
  in
  if exists then
    let var = List.find (fun a -> if a.varname = v then true else false) symbols
    in
    var
  else (* then try to find it in global table *)
    let exists2 = List.exists (fun a -> if a.varname = v ^ "_global_var" then true else false) symbols
    in
    if exists2 then
      let var = List.find (fun a -> if a.varname = v ^ "_global_var" then true else false) symbols
      in
      { varname = v; vartype = var.vartype }
    else
      raise (Failure ("Unable to find " ^ v ^ " in symbol table"))

let rec string_of_expr symbols = function
    Literal(l) -> string_of_int l
  | Floatlit(l) -> string_of_float l (* cast to float..Java's default type is double *)
  | String(s) -> "\"" ^ s ^ "\""
  | Bool(s) -> s
  | Id(s) -> s
  | Paren(e)-> "("^string_of_expr symbols e ^ ")"
  | Transpose(e)->string_of_expr symbols e ^".transpose()"
  | Uminus(e) -> "-(" ^ string_of_expr symbols e ^ ")"
  | Not(e) -> "!(" ^ string_of_expr symbols e ^ ")"
  | Binop(e1, o, e2) -> (* need to handle special cases here where e1 is a matrix type*)
      let e1_decl = type_of_expr symbols e1
      in
      let e2_decl = type_of_expr symbols e2
      in
      if e1_decl.vartype = "matrix" && (e2_decl.vartype="int" || e2_decl.vartype="float") then
        let op = 
          (match o with
             Add -> "OPERATION.ADD" | Sub -> "OPERATION.SUB" |
             Mul|Emul -> "OPERATION.MUL" | Div|Erdiv -> "OPERATION.DIV" | Power->"OPERATION.POW"|
             Ldiv|Eldiv|Equal|Neq|Less | Leq | Greater | Geq |
             And | Or  ->
               raise (Failure ("For " ^ e1_decl.varname ^ " and " ^ e2_decl.varname ^", the only arithmetic operations allowed for matrix are +, -, *, /, ./ and ^"))
          )
        in
        "matrixOperations(" ^ string_of_expr symbols e1 ^ ", " ^ 
                                  string_of_expr symbols e2 ^ ", " ^
                                  op ^ ")"
      else if  e2_decl.vartype = "matrix" && (e1_decl.vartype="int" || e1_decl.vartype="float") then
        let op = 
          (match o with
             Add -> "OPERATION.ADD" | Sub -> "OPERATION.SUB" |
             Mul|Emul -> "OPERATION.MUL" | Div|Erdiv -> "OPERATION.DIV" |
             Ldiv|Eldiv|Equal|Neq|Less | Leq | Greater | Geq |Power|
             And | Or  ->
               raise (Failure ("For " ^ e1_decl.varname ^ " and " ^ e2_decl.varname ^", the only arithmetic operations allowed for matrix are +, -, *, / and./"))
          )
        in
	"matrixOperations(" ^ string_of_expr symbols e1 ^ ", " ^ 
                                  string_of_expr symbols e2 ^ ", " ^
                                  op ^ ")"        
      else if e2_decl.vartype = "matrix" && e1_decl.vartype="matrix" then
	let op = 
          (match o with
             Add -> "OPERATION.ADD" | Sub -> "OPERATION.SUB" |
             Mul -> "OPERATION.MUL" | Ldiv-> "OPERATION.LDIV"|
             Emul-> "OPERATION.EMUL"| Erdiv-> "OPERATION.ERDIV"|
             Eldiv-> "OPERATION.ELDIV"|
              Equal|Neq|Less | Leq | Greater | Geq |Div|
             And | Or | Power -> 
               raise (Failure ("For " ^ e1_decl.varname ^ " and " ^ e2_decl.varname ^", the only arithmetic operations allowed for matrix are +, -, *, /, .*, ./, \\")))
        in
        "matrixOperations(" ^ string_of_expr symbols e1 ^ ", " ^ 
                                  string_of_expr symbols e2 ^ ", " ^
                                  op ^ ")"  
      else
        let op = 
          (match o with
             Power -> "POWER"
           | _ -> "")
        in
        if op = "POWER" then
          if (e1_decl.vartype = "int" && e2_decl.vartype = "int")
            || (e1_decl.vartype = "float" && e2_decl.vartype = "float")
            || (e1_decl.vartype = "int" && e2_decl.vartype = "float")
            || (e1_decl.vartype = "float" && e2_decl.vartype = "int")
            then
            "Math.pow(" ^ string_of_expr symbols e1 ^ ", " ^
                               string_of_expr symbols e2 ^ ")"
          else if e1_decl.vartype = "matrix" && (e2_decl.vartype = "int" || e2_decl.vartype="float") then
            "matrixOperations(" ^string_of_expr symbols e1 ^ ", " ^string_of_expr symbols e2 ^ ","^"OPERATION.POW"^")"
          else "" (* semantics.ml should block this *)
        else
          string_of_expr symbols e1 ^ " " ^
           (match o with
	     Add -> "+" | Sub -> "-" | Mul -> "*" | Div -> "/"
           | Equal -> "==" | Neq -> "!="
           | Less -> "<" | Leq -> "<=" | Greater -> ">" | Geq -> ">="
           | And -> "&&" | Or -> "||"
           | Power -> "" (* this should never match! *)  
           |_->raise (Failure ("Operation not allowed for "^ string_of_expr symbols e1^ " and " ^ string_of_expr symbols e2^"."  ))
          ) ^" "^string_of_expr symbols e2
  | Assign(v, e) -> 
        v ^ " = " ^ string_of_expr symbols e      
  | Call(f, el) ->
      let symbols_list = build_list (symbols, List.length el, [])
      in
      if f = "mod" then
        let e1 = List.nth el 0 in
        let e2 = List.nth el 1 in
        string_of_expr symbols e1 ^ " % " ^ string_of_expr symbols e2
      else if f = "inv" then
     	let e1 = List.nth el 0 in
     	string_of_expr symbols e1 ^ ".inverse()"
       else if f = "tostring" then
	let e = List.nth el 0 in
          "String.valueOf(" ^ string_of_expr symbols e ^ ")"
      else
        fcall f ^ "(" ^ String.concat ", " (List.map2 string_of_expr symbols_list el) ^ ")"
  | Datatype(_) -> ""
  | Newmat(e1, e2)->
        "new Matrix(" ^ string_of_expr symbols e1 ^ ", " ^ 
                   string_of_expr symbols e2 ^ ")"
  | AssignMatrix(id, indexList, value) ->  
     let i1=List.nth indexList 1 in
     let i2=List.nth indexList 0 in
     id ^".set(" ^string_of_expr symbols i1 ^", " ^string_of_expr symbols i2 ^ ", " ^string_of_expr symbols value ^")" 
  | MatrixAccess(id, indexList) ->
     let i1=List.nth indexList 1 in
     let i2=List.nth indexList 0 in
     id ^".get("^string_of_expr symbols i1^", "^ string_of_expr symbols i2^")"   
  | MatrixRAccess(id, i1, i2, j1, j2) ->
     "getSubMatrix(" ^ id ^ ", " ^ (string_of_expr symbols i1) ^ ", " ^ (string_of_expr symbols i2) ^ ", " ^ (string_of_expr symbols j1) ^ ", " ^ (string_of_expr symbols j2) ^ ")"
(*let rec string_of_stmt retname = function*)

(* convert 2D matrix to 1D matrix *)
(* e.g. 3x3 to 1x9 *)
let rec expand_matrix_list a l =
  let lr = List.rev l
  in a @ lr


let rec string_of_stmt symbols = function
    Block(stmts) ->
      (*let retname_list = build_list (retname, List.length stmts, [])*)
      let symbols_list = build_list (symbols, List.length stmts, [])
      in
      (*"{\n" ^ String.concat "" (List.map2 string_of_stmt retname_list stmts) ^ "}\n"*)
      "{\n" ^ String.concat "" (List.map2 string_of_stmt symbols_list stmts) ^ "}\n"
  | Expr(expr) -> begin
      match expr with
        (* we ignore stmts that don't have lvalue to store the result of an expr *)
        Literal(_) | Floatlit(_) | String(_) | Id(_) | Uminus(_) | Binop(_, _, _) -> ""
      | _ -> string_of_expr symbols expr ^ ";\n";
    end 
  | If(e, s1, s2) ->  "if (" ^ string_of_expr symbols e ^ ")\n" ^
      string_of_stmt symbols s1 ^ "else\n" ^ string_of_stmt symbols s2
  | Ifelseif(e, s1, eif_list, s2) -> 
      let rec print_elseif eif =
        "else if(" ^ string_of_expr symbols eif.elseif_expr ^ ")\n" ^
        string_of_stmt symbols eif.elseif_stmt
      in
      "if (" ^ string_of_expr symbols e ^ ")\n" ^ string_of_stmt symbols s1 ^
      (String.concat "" (List.map print_elseif eif_list)) ^ "else\n" ^ string_of_stmt symbols s2
  | For(Assigna(v, e1, e2), s) ->
      "for (" ^ v ^ " = " ^ string_of_expr symbols e1 ^ " ; " ^ v ^ " <= " ^ string_of_expr symbols e2 ^ " ; " ^ 
      v ^ "++)" ^ string_of_stmt symbols s
  | For(Assignb(v, e1, e2, e3), s) -> begin
      match e2 with
        Literal(l) ->
          if l = 0 then
            raise (Failure ("increment value cannot be zero"))
          else
            "for (" ^ v ^ " = " ^ string_of_expr symbols e1 ^ " ; " ^ v ^ " <= " ^ string_of_expr symbols e3 ^ " ; " ^
            v ^ " += " ^ string_of_expr symbols e2 ^ ")" ^ string_of_stmt symbols s
      | Floatlit(l) ->
          if l = 0.0 then
            raise (Failure ("increment value cannot be zero"))
          else
            "for (" ^ v ^ " = " ^ string_of_expr symbols e1 ^ " ; " ^ v ^ " <= " ^ string_of_expr symbols e3 ^ " ; " ^
            v ^ " += " ^ string_of_expr symbols e2 ^ ")" ^ string_of_stmt symbols s
      | Uminus(Literal(l)) ->
          if l = 0 then
            raise (Failure ("increment value cannot be zero"))
          else
            "for (" ^ v ^ " = " ^ string_of_expr symbols e1 ^ " ; " ^ v ^ " >= " ^ string_of_expr symbols e3 ^ " ; " ^
            v ^ " += " ^ string_of_expr symbols e2 ^ ")" ^ string_of_stmt symbols s
      | Uminus(Floatlit(l)) -> 
          if l = 0.0 then
            raise (Failure ("increment value cannot be zero"))
          else
            "for (" ^ v ^ " = " ^ string_of_expr symbols e1 ^ " ; " ^ v ^ " >= " ^ string_of_expr symbols e3 ^ " ; " ^
            v ^ " += " ^ string_of_expr symbols e2 ^ ")" ^ string_of_stmt symbols s
      | _ -> raise (Failure ("increment value must be an integer or float literal: " ^ string_of_expr symbols e2))
    
    end
    
    
  | While(e, s) -> "while (" ^ string_of_expr symbols e ^ ") " ^ string_of_stmt symbols s 
  | MatrixInit(k, l) -> 
      let elist = List.fold_left expand_matrix_list [] l
      in
      let symbols_list = build_list (symbols, List.length elist, [])
      in
      let slist = List.map2 string_of_expr symbols_list elist
      in
      let col = string_of_int (List.hd (List.map (fun subl -> List.length subl) l))
      in
      let row = string_of_int (List.length l)
      in
      k ^ " = matrixInit (" ^ row ^ ", "
                            ^ col ^ ", new double[]{" ^
                           (String.concat ", " slist) ^ "});\n"
  | Break-> "break"
  | Continue-> "continue"
let string_of_vdecl var = java_type_of var.vartype ^ " " ^ var.varname ^ " = " ^
  initial_value var.vartype ^ ";\n"

let string_of_global_vdecl var =
  "public static " ^ java_type_of var.vartype ^ " " ^ var.varname ^ " = " ^ 
  initial_value var.vartype ^ ";\n"

(* declare return variable *)
let retvar_decl fdecl = 
  if fdecl.rettype = "void" then ""
  else java_type_of fdecl.rettype ^ " " ^ fdecl.retname ^ " = " ^ 
  initial_value fdecl.rettype ^ ";\n"

(* return retname *)
let retvar_return fdecl =
  if fdecl.rettype = "void" then ""
  else "return " ^ fdecl.retname ^ ";\n"

let string_of_fdecl fdecl globals =
  (* let retname_list = build_list (fdecl.retname, List.length fdecl.body, []) *)
  let symbols = globals @ fdecl.locals @ fdecl.formals @ [{ varname = fdecl.retname; vartype = fdecl.rettype}]
  in
  let symbols_list = build_list (symbols, List.length fdecl.body, [])
  in
  fsignature fdecl ^ "\n{\n" ^
  retvar_decl fdecl ^
  String.concat "" (List.map string_of_vdecl fdecl.locals) ^
  (* String.concat "" (List.map2 string_of_stmt retname_list fdecl.body) ^ *)
  String.concat "" (List.map2 string_of_stmt symbols_list fdecl.body) ^
  retvar_return fdecl ^
  "}\n"

(*
let rec merge_vars_funcs vars funcs =
  if List.length funcs = 0 then vars
  else
    let func = List.hd funcs
    in 
    { varname = func.fname; vartype = func.rettype } :: merge_vars_funcs vars (List.tl funcs)
*)

let string_of_program (vars, funcs) className=
  (* let globals = merge_vars_funcs vars funcs *)
  let global_funcs = List.map (fun a -> { varname = a.fname ^ "_global_func"; vartype = a.rettype }) funcs
  in
  let global_vars = List.map (fun a -> { varname = a.varname ^ "_global_var"; vartype = a.vartype }) vars
  in
  let globals = global_funcs @ global_vars (* concatenate global variables and global functions to form symbols *)
  in
  let globals_list = build_list (globals, List.length funcs, [])
  in
  import_decl ^ "public class " ^className^ " {\n"^class_decl ^
  String.concat "" (List.map string_of_global_vdecl vars) ^ "\n" ^
  String.concat "\n" (List.map2 string_of_fdecl funcs globals_list) ^ "\n}\n" ^
  "\n"
